/***************************************************************************
© F. Rousset, R. Leblois 2007

francois.rousset@univ-montp2.fr
raphael.leblois@mnhn.fr

This file is part of Migraine. This software is a computer program
whose purpose is to perform statistical analyses.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/
#ifndef H_DG
#define H_DG
typedef long double scaledTimeType;
typedef long double factortype; // really needs to be long double, see declaration of factor in mainDG


//#define FLOAT_CALC   // gagne 33% en IBD, gagne 10% en onPopGSM,
#ifdef FLOAT_CALC
//#define cumultype float // a bit more tricky than typedef (primer p. 210--211)
//not clear which is faster
typedef float cumultype;
typedef float changetype;
typedef double pirestype; // type de PIs... seems to matter for large matrices... default double
typedef double picalctype; // interne PicalcPIM; qq avertiss 1=1 mais pas de plantage en Win32 et IFR .... default double
typedef float pascumultype; // interne Change mais pas Random et Cumul default = float changed (FR) to double 19/10/2010 proves important for large arrays of pops
typedef float parstype; //default = float changed (FR) to double 19/10/2010 proves important for large arrays of pops
/* problem when the above was float: differences between win and linux (and from the double version), error different for different parameter points and different loci,
but identical among replicate PAC sequences (IS not tested), dependent on order of loci... increasing error in computation of the change fn value as the number of remaining genes decreases. But not dependent on
Change fn itself, ie identical results with ChangefnPtr -> LDLsym et sparsified (conjugate-gradient+island)*/

#else
//#define cumultype double
typedef long double cumultype;//RL : passage en double puis long double car la procedure de SMM/GSM me donnait des Proposal qui ne sommaient pas [`a] 1 mais 1.0000012...
typedef long double changetype;
typedef long double pirestype; // type de PIs... seems to matter for large matrices and for SMM models because some Pi are very small...
typedef long double picalctype;
typedef long double pascumultype; // CBR (27.11.2013) changed from double to long double (NB. FLOAT_CALC equivalent is specified in double)
typedef long double parstype; // CBR (27.11.2013) changed from double to long double (NB. FLOAT_CALC equivalent is specified in double)
/* problem when the above was float and sometimes also for double : differences between win and linux (and from the double version), error different for different parameter points and different loci,
but identical among replicate PAC sequences (IS not tested), dependent on order of loci... increasing error in computation of the change fn value as the number of remaining genes decreases. But not dependent on
Change fn itself, ie identical results with ChangefnPtr -> LDLsym et sparsified (conjugate-gradient+island)*/
#endif //float_calc

#include <iomanip>
#include <string>
#include <cstdlib>
#include <fstream>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <valarray>

#include "locus.h" // CProcessedLocus
#include "genepop.h" // pour cmp_nocase... afaire: deplacer dans utils
#include "MersenneTwister.h"


extern pirestype** PIs;
extern pirestype* bvec; // that should become obsolete as a class member ?
extern picalctype* v_;
extern picalctype** L_;  // new une fois par calclogl (new_L_...) et delete idem
extern picalctype* D_;
extern picalctype** Mmat;
extern picalctype*** MatriceSD;//pour calcul PiOnePop SD2001
extern picalctype* SDpivec;
extern picalctype** MatA;
extern int chosenPop;


//new set of PI variables for the AlternativeIS_FRExpMixAncActPopSizebool
//for the OnePopVarSize model I only need the PIs
extern pirestype** altPIs;

extern bool firstCountPSON;
extern int firstPSON;
extern std::vector<bool> firstCallOfLocus;
extern std::vector<int>finalSMMstepSizes;

#define PI 3.141592654
#define sq(a) ((a)*(a))
#define Rho(k,B) 2*(k)*PI/(B)


#endif
