/***************************************************************************
© F. Rousset, R. Leblois 2007

francois.rousset@univ-montp2.fr
raphael.leblois@mnhn.fr

This file is part of Migraine. This software is a computer program
whose purpose is to perform statistical analyses.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/
#ifndef H_LATIN
#define H_LATIN
#include <sstream>
#include <vector>
#include <string>
#include "locus.h" //CProcessedLocus // must be read before migraine.h
#include "migraine.h" //PointNumber
#include "MersenneTwister.h"

const std::string datestring=__DATE__;
const std::string timestring=__TIME__;


extern int JobMin,JobMax,pointmin,pointmax,_pointmin,_pointmax,MaxSimultJobs;
#ifdef UNIX_PARAL // compiler -DUNIX_PARAL
extern int AvailableProcessors;
#endif
extern std::string VarSizeFunction;
extern bool pacbool,pacancbool,AlternativeIS_AncPopSizebool,AlternativeIS_FRExpMixAncActPopSizebool,pcgbool,asymptoBool,AsymptoPerMutRateBool,
	AsymptoPerDispRateBool,HobolthISM,noHyperSegSites,
    genepopBool,genepopRootBool,nexusBool,nexusRootBool,nexusNumberLabels,sameGpNexusLabels,promptHyperSegSites,outlierGeneFileBool,pauseFinal
    ,pipimbool,piOnePopSDbool,piOnePopEigenbool,PopSizeScaleForTimebool, allowsEmptyColumns,TMRCABool;
extern MTRand alea,aleah;
extern std::string ptlname,version,resolveForPerfectPhylogeny;
extern float *lb, *ub; //new without delete in apply_final_settings... delete[`a] la fin du main
extern unsigned long int _ptSamplingSeed,_EstimationSeed;
extern std::string settingsfilename;

//int cmp_nocase(const string& s, const string& s2);
//void rtrim(string *s);
int analyse(int mls,int tranche);
int analyse(int mls);




class COptions {
std::vector<std::string> liste;
std::ostringstream ost;
//... so that one can use an alternative to sprintf() where no char[] definition is needed
//(A string stream is a stream that writes to a string instead of a file. You can declare
//it without giving a maximum length, and you can keep appending strings to it.)
int Oappend(std::string st);
public:
COptions();
int Ocollect();
int Oinspect(std::ostream& st);
};




#endif //H_LATIN
