/***************************************************************************
© F. Rousset, R. Leblois 2007

francois.rousset@univ-montp2.fr
raphael.leblois@mnhn.fr

This file is part of Migraine. This software is a computer program
whose purpose is to perform statistical analyses.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/
#ifndef MAINDG_H
#define MAINDG_H

//#include "dg.h"
#include "migraine.h"

namespace NS_calclogl {
  //FR->RL expliquer chaq variable et en profiter pour nettoyer le code...
  extern int MigParamNbr,ChangeTimeParamNbr,RelAncPopSizeParamNbr,AncThetaParamNbr,VarSizeShapeParamNbr;
  extern std::vector<parstype> Disp_Pars;
  extern std::vector<parstype> _PopSizeTab, _AncPopSizeTab,_AncThetaTab;
  extern std::vector<scaledTimeType> _ChangeTimeTab;
  extern parstype _VarSizeShape;
  extern parstype _Theta; // copies local de (possibly scaled) args.pars[0]
  extern parstype _pGSM; // copies local de args.pars[1] for GSM
  extern parstype _ThetaMIC; // used to assign MutMod1->AncThetaDIG for the ISM model when multipleMarkersBool = true
  extern int MutScaling;
  extern parstype Temp;
  extern   long double LnLikelihood,MultinomialCoeff, LnMeanLikelihood;
  extern std::vector <int> LineagesPerPopAtDivTime;
  extern int PopMerged;
  extern bool Changedbool;//if changes occured in FctnPtr (PiCalc and IS/PAC) and Mig and Mut models in the split model
  extern int ancEventIt; //iterator over ancestral events
  extern bool beforeLastEvent; //fast test whether ancestral events should be looked at.
  extern int localallelenbr; // info sur nombre d'alleles connu ou a deduire d'un fichier de donnees
}


extern bool golubbool,runsTempFileBool,UsePCL_SISRbool,ForceGivenKbool;


//float alea();
std::vector<float> calclogl(const Arguments args,CMigMod *MigMod1);
double gammln(double xx);
double Euclidian(std::vector<pirestype> &veca,std::vector<pirestype> &vecb);
picalctype Ccc(int pas,picalctype r);//Solution d'integrale pour PiTwoPop SMM et GSM Deiorio et al 2006
int inversion( picalctype** A,int _Size);
#endif


